Attribute VB_Name = "TestProjekt"
' -----------------------------------------------
' MP3-Header auslesen mit einer DLL Version 1.6
' entwickelt von Stefan Tngi      27.12.2001
' Update auf Version 1.6 am 20.04.2003

' ***********************************************
' **          http://www.toengi.de             **
' ***********************************************

' -----------------------------------------------
'                     FREEWARE
' -----------------------------------------------
'
'Copyright (c) 2001-2003, Stefan Tngi
'
'THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
'"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
'LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
'A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
'CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
'EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
'PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
'PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
'LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
'NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
'SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
'
'
' Dimensionierung der Struktur zum Ansprechen
Global mpg As mpgstruct

' Array fr Ja/Nein-Auskunft
Global YesNo(-1 To 1) As String ' -1=Fehler,0=Nein,1=ja

' Platz fr Dateiname
Global Datei As String
 '
Sub Main()
  YesNo(-1) = "Error"
  YesNo(0) = "No"
  YesNo(1) = "Yes"
  Form1.Show
End Sub
Sub Darstell()
  ' Auswerten des ausgewhlten Files
  Form1.List1.Clear
  Form1.Command3.Enabled = False
  Form1.Command2.Enabled = False
  Form1.Command4.Enabled = False
  Form1.Command5.Enabled = False
  Form1.Command6.Enabled = False
  Mp3FileInfo Datei, mpg
  If mpg.ValidHeader <> 1 Then
    Form1.List1.AddItem "Ungltiger Header! Evtl. keine gltige MP3-Datei"
    Exit Sub
  End If
  Form1.Command2.Enabled = True ' ID3V1 ndern mglich
  tmp$ = "Size:" & mpg.FileSize & " bytes  Len:" & mpg.Duration & " sec [" & Format$(mpg.Minutes, "00") & ":" & Format$(mpg.Seconds, "00") & "]"
  Form1.List1.AddItem tmp$
  tmp$ = "First Header found at Pos:" & mpg.HeaderPos
  Form1.List1.AddItem tmp$
  Select Case mpg.MpegID
  Case -1: tmp$ = "MPEG Error"
  Case 0: tmp$ = "MPEG reserve"
  Case 1: tmp$ = "MPEG 1.0"
  Case 2: tmp$ = "MPEG 2.0"
  Case 3: tmp$ = "MPEG 2.5"
  End Select
  tmp$ = tmp$ & " Layer " & mpg.Layer & "  "
  If mpg.VBR = 1 Then
   tmp$ = tmp$ & mpg.Bitrate & "kbit (VBR)"
  Else
   tmp$ = tmp$ & mpg.Bitrate & "kbit (CBR)"
  End If
  Form1.List1.AddItem tmp$
  tmp$ = mpg.FrameCount & " frames  "
  tmp$ = tmp$ & mpg.Samplerate & "hz " & Choose(mpg.Stereomode + 1, "Stereo", "Joint Stereo", "Zweikanal", "Mono")
  Form1.List1.AddItem tmp$
  tmp$ = "CRCs:" & YesNo(mpg.CRC) & " Copyright:" & YesNo(mpg.Copyright) & " Original:" & YesNo(mpg.Original)
  Form1.List1.AddItem tmp$
  Select Case mpg.Emphasis
  Case -1: tmp$ = "Emphasis: Error"
  Case 0: tmp$ = "Emphasis: 50/15ms"
  Case 1: tmp$ = "Emphasis: CCITT"
  End Select
  Form1.List1.AddItem tmp$
  Select Case mpg.ID3V1Header
  Case -1: tmp$ = "ID3v1: Error"
  Case 0: tmp$ = "ID3v1: No"
  Case 1: tmp$ = "ID3v1: Version 1.0"
  Case 2: tmp$ = "ID3v1: Version 1.1"
  End Select
  Form1.List1.AddItem tmp$
  If mpg.ID3V1Header > 0 Then Form1.Command3.Enabled = True
  If mpg.ID3V2Header = 1 Then
   tmp$ = "ID3v2." & mpg.ID3V2MajorVer & "." & mpg.ID3V2MinorVer
   tmp$ = tmp$ & " found at Byte " & mpg.ID3V2Pos
   tmp$ = tmp$ & " with " & mpg.ID3V2Len & " bytes"
   Form1.Command5.Enabled = True
   Form1.Command6.Enabled = True
  Else
   tmp$ = "ID3v2: No"
  End If
  Form1.List1.AddItem tmp$
  Select Case mpg.Lyrics
  Case -1: tmp$ = "Lyrics3: Error"
  Case 0: tmp$ = "Lyrics3: No"
  Case 1: tmp$ = "Lyrics3: Version 1.00 at Byte " & mpg.LyricsPos
  Case 2: tmp$ = "Lyrics3: Version 2.00 at Byte " & mpg.LyricsPos
  End Select
  Form1.List1.AddItem tmp$
  If mpg.Lyrics > 0 Then Form1.Command4.Enabled = True ' Lyrics lschen mglich
  tmp$ = "Title  :" & mpg.Title
  Form1.List1.AddItem tmp$
  frmID3V1.ID3Titel = Trim$(mpg.Title)
  tmp$ = "Artist :" & mpg.Artist
  Form1.List1.AddItem tmp$
  frmID3V1.ID3Interpret = Trim$(mpg.Artist)
  tmp$ = "Album  :" & mpg.Album
  Form1.List1.AddItem tmp$
  frmID3V1.ID3Album = Trim$(mpg.Album)
  tmp$ = "GenreID:" & mpg.GenreID & " = " & mpg.Genre
  frmID3V1.ID3Genre = mpg.GenreID
  Form1.List1.AddItem tmp$
  tmp$ = "Year: " & mpg.Year & "  Track #:" & IIf(mpg.TrackNr > 0, Str$(mpg.TrackNr), " ")
  Form1.List1.AddItem tmp$
  frmID3V1.ID3Jahr = Trim$(mpg.Year)
  frmID3V1.ID3Track = IIf(mpg.TrackNr > 0, Str$(mpg.TrackNr), " ")
  tmp$ = "Rem: " & mpg.Comment
  Form1.List1.AddItem tmp$
  frmID3V1.ID3Kommentar = mpg.Comment
  frmID3V2.Label3(0) = Trim$(mpg.ID3V2Track)
  frmID3V2.Label3(1) = Trim$(mpg.ID3V2Title)
  frmID3V2.Label3(2) = Trim$(mpg.ID3V2Artist)
  frmID3V2.Label3(3) = Trim$(mpg.ID3V2Album)
  frmID3V2.Label3(4) = Trim$(mpg.ID3V2Year)
  frmID3V2.Label3(5) = Trim$(mpg.ID3V2Genre)
  frmID3V2.Label3(6) = Trim$(mpg.ID3V2Composer)
  frmID3V2.Label3(7) = Trim$(mpg.ID3V2OriginalArtist)
  frmID3V2.Label3(8) = Trim$(mpg.ID3V2Copyright)
  frmID3V2.Label3(9) = Trim$(mpg.ID3V2Url)
  frmID3V2.Label3(10) = Trim$(mpg.ID3V2Encoder)
  frmID3V2.Text1 = Trim$(mpg.ID3V2Comment)
  
  
End Sub
